using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Wo_AwardRecord
	/// </summary>
	public partial class T_Wo_AwardRecord
    {
        public T_Wo_AwardRecord()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_AwardRecord");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(CallCenterApi.Model.T_Wo_AwardRecord model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_AwardRecord(");
            strSql.Append("F_WorkOrderId,F_openid,F_RewardAmount,F_RewardTime,F_RewardUser,F_IsState,F_IsSendState,F_Remark,F_CreateUser,F_CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_openid,@F_RewardAmount,@F_RewardTime,@F_RewardUser,@F_IsState,@F_IsSendState,@F_Remark,@F_CreateUser,@F_CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_openid", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_RewardAmount", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_RewardTime", SqlDbType.DateTime),
                    new SqlParameter("@F_RewardUser", SqlDbType.Int,4),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_IsSendState", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_openid;
            parameters[2].Value = model.F_RewardAmount;
            parameters[3].Value = model.F_RewardTime;
            parameters[4].Value = model.F_RewardUser;
            parameters[5].Value = model.F_IsState;
            parameters[6].Value = model.F_IsSendState;
            parameters[7].Value = model.F_Remark;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Wo_AwardRecord model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_AwardRecord set ");
            strSql.Append("F_WorkOrderId=@F_WorkOrderId,");
            strSql.Append("F_openid=@F_openid,");
            strSql.Append("F_RewardAmount=@F_RewardAmount,");
            strSql.Append("F_RewardTime=@F_RewardTime,");
            strSql.Append("F_RewardUser=@F_RewardUser,");
            strSql.Append("F_IsState=@F_IsState,");
            strSql.Append("F_IsSendState=@F_IsSendState,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_CreateTime=@F_CreateTime");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_openid", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_RewardAmount", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_RewardTime", SqlDbType.DateTime),
                    new SqlParameter("@F_RewardUser", SqlDbType.Int,4),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_IsSendState", SqlDbType.Int,4),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_openid;
            parameters[2].Value = model.F_RewardAmount;
            parameters[3].Value = model.F_RewardTime;
            parameters[4].Value = model.F_RewardUser;
            parameters[5].Value = model.F_IsState;
            parameters[6].Value = model.F_IsSendState;
            parameters[7].Value = model.F_Remark;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_CreateTime;
            parameters[10].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_AwardRecord ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_AwardRecord ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
		/// 得到一个对象实体
		/// </summary>
		public CallCenterApi.Model.T_Wo_AwardRecord GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_WorkOrderId,F_openid,F_RewardAmount,F_RewardTime,F_RewardUser,F_IsState,F_IsSendState,F_Remark,F_CreateUser,F_CreateTime from T_Wo_AwardRecord ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            CallCenterApi.Model.T_Wo_AwardRecord model = new CallCenterApi.Model.T_Wo_AwardRecord();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_AwardRecord DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Wo_AwardRecord model = new CallCenterApi.Model.T_Wo_AwardRecord();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_openid"] != null)
                {
                    model.F_openid = row["F_openid"].ToString();
                }
                if (row["F_RewardAmount"] != null)
                {
                    model.F_RewardAmount = row["F_RewardAmount"].ToString();
                }
                if (row["F_RewardTime"] != null && row["F_RewardTime"].ToString() != "")
                {
                    model.F_RewardTime = DateTime.Parse(row["F_RewardTime"].ToString());
                }
                if (row["F_RewardUser"] != null && row["F_RewardUser"].ToString() != "")
                {
                    model.F_RewardUser = int.Parse(row["F_RewardUser"].ToString());
                }
                if (row["F_IsState"] != null && row["F_IsState"].ToString() != "")
                {
                    model.F_IsState = int.Parse(row["F_IsState"].ToString());
                }
                if (row["F_IsSendState"] != null && row["F_IsSendState"].ToString() != "")
                {
                    model.F_IsSendState = int.Parse(row["F_IsSendState"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_WorkOrderId,F_openid,F_RewardAmount,F_RewardTime,F_RewardUser,F_IsState,F_IsSendState,F_Remark,F_CreateUser,F_CreateTime ");
            strSql.Append(" FROM T_Wo_AwardRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_WorkOrderId,F_openid,F_RewardAmount,F_RewardTime,F_RewardUser,F_IsState,F_IsSendState,F_Remark,F_CreateUser,F_CreateTime ");
            strSql.Append(" FROM T_Wo_AwardRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_AwardRecord ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_AwardRecord T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Wo_AwardRecord";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 更新红包发送状态
        /// </summary>
        public bool UpdateState(int id,int isstate)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_AwardRecord set ");
            strSql.Append("F_IsSendState=@F_IsSendState");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_IsSendState", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = isstate;
            parameters[1].Value = id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        #endregion  ExtensionMethod
    }
}
